/* Human68k Ǘ */

/* Copyright (C) 1994 Yasuo Soda. */

/* 1994-01-09, ]c חY */

#include "doscall.h"
#include "ptrs.h"
#include "ptrsmacro.h"	/* ptrsBufSize */

extern void *sbrk(int);

    /* Human68kǗ|C^\ */
struct osMemLink {
    struct osMemLink *prev;
    struct osMemLink *thisProg;	/* {̃vO */
    void *lastAddr;		/* ubN̏I[AhX */
    struct osMemLink *next;
};

/*
* pageSizemallocCuBLOCKSIZEƓłȂ΂ȂȂB
*/
#define pageSize 4096
#define raiseToPageSized(a) ((a) + (pageSize-1) & ~(pageSize-1))
#define truncateToPageSized(a) ((a) & ~(pageSize-1))

    /* ȏ̒]΃ubNk߂̒ */
#define reclamationDecrement 8

    /* ubNo^IuWFNg */
static struct _ptrs banana;
static int initialized;

    /* ubÑ|C^z */
void **_ptrs_buf;

/***********
* I
************/
static void giveBackEach(void *blk, int ign) {
    MFREE(blk);
}

/*
* _freeall֐
*
* gׂăVXeɕԋpB
*
*/
void _freeall(void) {
    if (initialized) {
	_ptrs_en(&banana, giveBackEach, 0);
	_ptrs_free(&banana);
	/* xsȂ悤 */
	initialized = 0;
    }
}

/***********
* 폜
************/
    /* œn؂Ȃ */
static void *freeStartAddr, *freeStopAddr;

static int survivalTest(void *blk, int flgPtr) {
    void *blkStart, *blkEnd;

    blkStart = (void *)raiseToPageSized((unsigned long)blk);
    blkEnd = (void *)truncateToPageSized((unsigned long)
	((struct osMemLink *)blk - 1)->lastAddr);

    /* ubNŜł邩 */
    if (blkStart == freeStartAddr && blkEnd == freeStopAddr) {
	MFREE(blk);
	*(int *)flgPtr = 1;
	/* o^𖕏 */
	return 0;
    }
    /* 邢̓ubŇ폜ł邩 */
    else if (blkStart < freeStartAddr && blkEnd == freeStopAddr
	    && (char *)freeStopAddr - (char *)freeStartAddr
		>= reclamationDecrement * pageSize) {
	SETBLOCK(blk, (char *)raiseToPageSized((unsigned long)freeStartAddr)
		- (char *)blk);
	*(int *)flgPtr = 1;
    }

    /* gp */
    return 1;
}

/*
* _removergn֐
*
* ptrʒulenoCg̃VXeɕԂB
*
* ͈͂1̃ubNŜɋyԂA邢
* ubŇ[܂reclamationDecrement * pageSize
* oCgȏɋyԏꍇAۂɉsB
*
* ptrlen͋Ƀy[W̑傫ɑĂȂ΂ȂȂB
*
* ۂɉ0ԂBȂ-1ԂB
*
*/
int _removergn(void *ptr, int len) {
    int removed = 0;

    freeStartAddr = ptr;
    freeStopAddr = (char *)ptr + len;
    _ptrs_sel(&banana, survivalTest, (int)&removed);
    return removed ? 0 : -1;
}

/***********
* l
************/
    /* y[WŔ閳ʂ̋e(VXeubN
       ̒Oɉ݂̈Ȃ炻ƃ|C^1ȏ̑傫B) */
#define alignmentHoleTolerance 32

    /* q[v̈̐擪AhX */
static void *heapStart;

static int growthPossible(void *blk, int incr) {
    void *breakValue;

    breakValue = (void *)truncateToPageSized((unsigned long)
	((struct osMemLink *)blk - 1)->lastAddr);
    return SETBLOCK(blk, (char *)breakValue + incr - (char *)blk) >= 0
	? (int)breakValue : 0;
}

/*
* _getspc֐
*
* sbrk֐̋UBGNU libc v1.07mallocCupB
*
* VXeincroCg̃lq[v̈gB
*
* ̊JnAhXƑ傫́Ay[W̑傫ɑB
* ̌ĂяoŊl郁̃AhX́AA邱Ƃ
* ۏ؂ȂB2ڈȌ̌ĂяoŊlCӂ̃ԂŁA
* AhX̍֌WɈ̌܂͂ȂAׂĂK1
* 荂AhXɂȂB
*
* incrłĂq[v̈͏kȂB
*
* l̊JnAhXԂB0܂͕̈ɑ΂ẮA
* (void *)-1ԂB
*
*/
void *_getspc(int incr) {
    void *blk, *stk, *result;

    /*  */
    if (!initialized) {
	void *buf = sbrk(ptrsBufSize);
	_ptrs_buf = (buf != (void *)-1 ? (void **)buf : (void **)0);
	_ptrs_init(&banana, 256);
	initialized = 1;
    }

    if (incr <= 0)
	return (void *)-1;
    incr = raiseToPageSized(incr);

    /* ɊlubNgłȂ */
    result = (void *)_ptrs_find(&banana, growthPossible, incr);
    if (result)
	return result;

    stk = 0;
    for (;;) {
	blk = MALLOC2(0, incr);
	if ((int)blk < 0)
	    break;
	else if ((void *)raiseToPageSized((unsigned long)blk) < heapStart) {
	    /* q[v̈̐擪𒴂ĐLтĂ镔 */
	    if ((char *)blk + incr > (char *)heapStart - alignmentHoleTolerance)
		SETBLOCK(blk, (char *)heapStart - (char *)blk
			- alignmentHoleTolerance);
	}
	else {
	    int adj;

	    /* AhX */
	    adj = (unsigned long)blk % pageSize;
	    if (adj != 0 && adj < pageSize - alignmentHoleTolerance)
		SETBLOCK(blk, pageSize - adj - alignmentHoleTolerance
			+ sizeof(void *));
	    else {
		/*  */
		if (adj == 0) {
		    result = blk;
		    break;
		}
		else {
		    adj = pageSize - adj;
		    if (SETBLOCK(blk, incr + adj) >= 0) {
			result = (char *)blk + adj;
			break;
		    }
		}
		/* sɂ胊gC */
	    }
	}
	*(void **)blk = stk;
	stk = blk;
    }

    /* pfBO */
    while (stk) {
	void *next = *(void **)stk;
	MFREE(stk);
	stk = next;
    }

    /* s */
    if ((int)blk < 0)
	return (void *)-1;

    /* ubNo^ */
    if (_ptrs_add(&banana, blk) == -1) {
	MFREE(blk);
	return (void *)-1;
    }

    if (heapStart == 0)
	heapStart = result;

    /* l̃AhX𓚂 */
    return result;
}
