/* SX-WINDOW |C^֐ */

/* Copyright (C) 1994 Yasuo Soda. */

/* 1993-12-29, ]c חY */
/* 1994-01-07: SX-WINDOWR[h𕪗B */
/* 1994-01-09: _ptrs_findǉB */

/*
* |C^́A|C^̉ϏW\f[^^B
*/

#include <string.h>	/* memcpy */
#include "ptrs.h"

/*
* |C^z}N:
*
* ptrsAlloc(int)	|C^z񃁃lB
* ptrsFree(void **)	|C^z񃁃B
* ptrsAccess(void **)	zvfւ̃|C^߂B
* ptrsLock(void **)	|C^zbNB
* ptrsUnlock(void **)	|C^zbNB
*/
#include PTRSMACRO_H

    /* |C^z̏̑傫 */
#define defaultSize 1024

/*
* _ptrs_init֐
*
* |C^z̏̑傫w肵āAsB
*
* 傫0ȉȂAftHg̑傫̗pB
*
*/
void _ptrs_init(_Ptrs pa, int rooms) {
    pa->maxptr = rooms;
    pa->ptrs = 0;
}

/*
* _ptrs_free֐
*
* B
*
*/
void _ptrs_free(_Ptrs pa) {
    if (pa->ptrs)
	ptrsFree(pa->ptrs);
}

/*
* _ptrs_add֐
*
* |C^o^B
*
* o^0ԂBs-1ԂB
*
*/
int _ptrs_add(_Ptrs pa, void *ptr) {
    /*  */
    if (!pa->ptrs) {
	pa->nptrs = 0;
	if (pa->maxptr <= 0)
	    pa->maxptr = defaultSize;
	pa->ptrs = ptrsAlloc(sizeof(void *) * pa->maxptr);
	if (!pa->ptrs)
	    return -1;
    }

    /* |C^z񂪖tȂVɃm */
    if (pa->nptrs == pa->maxptr) {
	void **newPtrs;

	newPtrs = ptrsAlloc(sizeof(void *) * pa->maxptr * 2);
	if (!newPtrs)
	    return -1;
	memcpy(ptrsAccess(newPtrs), ptrsAccess(pa->ptrs), sizeof(void *) * pa->nptrs);
	ptrsFree(pa->ptrs);
	pa->ptrs = newPtrs;
	pa->maxptr *= 2;
    }

    (ptrsAccess(pa->ptrs))[pa->nptrs++] = ptr;
    return 0;
}

/*
* _ptrs_en֐
*
* |C^񋓂B
*
* o^ꂽ|C^Ɋ֐funcR[B
* ֐funcɂ̓|C^argnB
*
*/
void _ptrs_en(_Ptrs pa, void (*func)(void *, int), int arg) {
    int i;
    void **ptrs;

    if (!pa->ptrs)
	return;

    ptrsLock(pa->ptrs);
    ptrs = ptrsAccess(pa->ptrs);
    for (i = pa->nptrs; --i >= 0; )
	(*func)(*ptrs++, arg);
    ptrsUnlock(pa->ptrs);
}

/*
* _ptrs_find֐
*
* |C^TB
*
* o^ꂽ|C^Ɋ֐funcR[B
* ֐funcɂ̓|C^argnB
* ֐func0Ԃ炻ŏIB
*
* Ō̃R[Ŋ֐funcԂlԂB
* |C^o^ĂȂ0ԂB
*
*/
int _ptrs_find(_Ptrs pa, int (*func)(void *, int), int arg) {
    int i, result = 0;
    void **ptrs;

    if (!pa->ptrs)
	return 0;

    ptrsLock(pa->ptrs);
    ptrs = ptrsAccess(pa->ptrs);
    for (i = pa->nptrs; --i >= 0; ) {
	if (result = (*func)(*ptrs++, arg))
	    break;
    }
    ptrsUnlock(pa->ptrs);
    return result;
}

/*
* _ptrs_sel֐
*
* |C^ӂ邢ɂB
*
* o^ꂽ|C^Ɋ֐funcR[B
* ֐funcɂ̓|C^argnB
* ֐0Ԃ|C^폜B
*
*/
void _ptrs_sel(_Ptrs pa, int (*func)(void *, int), int arg) {
    int i;
    void **src, **dst;

    if (!pa->ptrs)
	return;

    ptrsLock(pa->ptrs);
    src = dst = ptrsAccess(pa->ptrs);
    for (i = pa->nptrs; --i >= 0; ) {
	if ((*func)(*src, arg))
	    *dst++ = *src++;
	else
	    src++;
    }
    ptrsUnlock(pa->ptrs);
    pa->nptrs += dst - src;
}
